#include "colors.inc"
#declare Gris = color red 0.85 green 0.85 blue 0.85

#declare Space = texture {
   pigment {
      leopard
      turbulence 1
      color_map {
         [0 color White]
         [0.2 color White]
         [0.3 color Gris]
         [0.4 color White]
         [0.7 color Gris]
         [1 color Gris]
      }
      scale <0.08,0.08,1>
   }
   normal {bumps 0.1 scale 0.01}
   finish {phong 0.3 reflection 0.2} }

#declare Panneau = texture {
    pigment {color Gray10}
    finish {phong 0.5 reflection 0.2} }

#declare Corps = union {
    intersection {
        sphere { <0,0,0>, 1
            texture {Space}
            texture {
                pigment {
                    image_map {
                        gif "corpsmap.gif"
                        once
                        interpolate 2
                        filter 0,1} }
                translate <-0.5,-0.5,0>
                scale 2}}
        plane {y,0.88}
        plane {-y,0.88}}
    difference {
        intersection {
            sphere {<0,0,0>,1}
            cylinder {<0,-1,0>,<0,1,0>,0.4}}
        box {<-1,0,-0.5>,<0,1,0.5> translate <-0.05,0.95,0>}
        box {<0,0,-0.5>,<1,1,0.5> translate <0.05,0.95,0>}}
    difference {
        cylinder {<0.3,-0.6,-0.8>,<0.3,-0.6,0>,0.1}
        cylinder {<0.3,-0.6,-0.9>,<0.3,-0.6,0>,0.02}}
    difference {
        cylinder {<-0.3,-0.6,-0.8>,<-0.3,-0.6,0>,0.1}
        cylinder {<-0.3,-0.6,-0.9>,<-0.3,-0.6,0>,0.02}}
    texture {Space}}

#declare Cut = plane {x,0.8 rotate <0,45,0>}

#declare Verriere = intersection {
    sphere {<0,0,0>,1}
    object {Cut rotate <0,0,0>}
    object {Cut rotate <0,0,45>}
    object {Cut rotate <0,0,90>}
    object {Cut rotate <0,0,135>}
    object {Cut rotate <0,0,180>}
    object {Cut rotate <0,0,225>}
    object {Cut rotate <0,0,270>}
    object {Cut rotate <0,0,315>}
    plane {-z,0.6}
    rotate <0,0,30>
    texture {
        pigment {color Gray10}
        finish {phong 1 reflection 1}}}

#declare Boulon = intersection {
    box {<-0.06,-0.6,-0.6>,<0.06,0.6,0.6>}
    plane {y,0.4 rotate <0,0,0>}
    plane {y,0.4 rotate <60,0,0>}
    plane {y,0.4 rotate <120,0,0>}
    plane {y,0.4 rotate <180,0,0>}
    plane {y,0.4 rotate <240,0,0>}
    plane {y,0.4 rotate <300,0,0>}}

#declare Axe = union {
    cylinder {<-3,0,0>,<3,0,0>,0.2}
    difference {
        cone {<0.8,0,0>,0.4,<1.9,0,0>,0.25 open}
        box {<0.8,-0.4,-0.2>,<1.9,0.4,0.2>}}
    difference {
        cone {<-0.8,0,0>,0.4,<-1.9,0,0>,0.25 open}
        box {<-1.9,-0.4,-0.2>,<-0.8,0.4,0.2>}}
    cylinder {<2.0,0,0>,<2.2,0,0>,0.24}
    cylinder {<-2.0,0,0>,<-2.2,0,0>,0.24}
    intersection {
        cone {<0.5,0,0>,0.6,<2.3,0,0>,0.3}
        box {<0.5,-0.6,-0.1>,<2.3,0.6,0.1>}}
    intersection {
        cone {<-0.5,0,0>,0.6,<-2.3,0,0>,0.3}
        box {<-2.3,-0.6,-0.1>,<-0.5,0.6,0.1>}}
    cylinder {<2.5,0,0>,<2.8,0,0>,0.24}
    cylinder {<-2.5,0,0>,<-2.8,0,0>,0.24}
    intersection {
        cone {<2.4,0,0>,0.3,<2.8,0,0>,0.5}
        box {<2.4,-0.02,-0.5>,<2.8,0.02,0.5>}}
    intersection {
        cone {<-2.4,0,0>,0.3,<-2.8,0,0>,0.5}
        box {<-2.8,-0.02,-0.5>,<-2.4,0.02,0.5>}}
    object {Boulon translate <2.85,0,0>}
    object {Boulon translate <-2.85,0,0>}
    texture {Space}}

#declare Cut_Aile = plane {y,3}

#declare Aile = intersection {
    union {
        box {<-0.02,-4.0,-4.0>,<0.02,4.0,4.0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space}
            rotate <0,0,0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space}
            rotate <60,0,0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space}
            rotate <120,0,0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space}
            rotate <180,0,0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space}
            rotate <240,0,0>}
        box {<-0.03,2.94,-4.0>,<0.03,3.0,4.0>
            texture {Space} rotate <300,0,0>}
        box {<-0.03,-0.03,-4.0>,<0.03,0.03,4.0>
            texture {Space} rotate <0,0,0>}
        box {<-0.03,-0.03,-4.0>,<0.03,0.03,4.0>
            texture {Space} rotate <60,0,0>}
        box {<-0.03,-0.03,-4.0>,<0.03,0.03,4.0>
            texture {Space} rotate <120,0,0>} }
    object {Cut_Aile rotate <0,0,0>}
    object {Cut_Aile rotate <60,0,0>}
    object {Cut_Aile rotate <120,0,0>}
    object {Cut_Aile rotate <180,0,0>}
    object {Cut_Aile rotate <240,0,0>}
    object {Cut_Aile rotate <300,0,0>}
    texture {Panneau} scale <1,1,0.7>}

#declare Tuyere = difference {
    intersection {
        cone {<0,0,0>,1,<0,0,2>,0 }
        plane {z,1.2}
        texture {Space}}
    cone {<0,0,1>,0,<0,0,2>,1 
        texture {pigment {color White}}}}

#declare Tie_Fighter = union {
    object {Corps}
    object {Tuyere}
    light_source {<0,0,1.2> color red 0.2 green 0 blue 0}
    object {Verriere scale 0.5 translate <0,0,-0.75>}
    object {Axe}
    object {Aile translate <2.88,0,0>}
    object {Aile translate <-2.88,0,0>}
}
